library ieee;
use ieee.std_logic_1164.all;

--******************************************************************************
--**** ENTITY memwb_c
--**** Deskripsi: Entity ini menguraikan Memory / Write Back control
--****            register. Nilai-nilai dituliskan ke register ini pada 
--****            clock positif.
--******************************************************************************
ENTITY memwb_c IS
    PORT(clk                                 : IN STD_LOGIC;
         wbIn                                : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
         wb_sel                              : OUT STD_LOGIC_VECTOR(1 DOWNTO 0);
         wb_enable                           : OUT STD_LOGIC);
END ENTITY memwb_c;

ARCHITECTURE memwbc_behav OF memwb_c IS
BEGIN
    name : PROCESS(clk) IS
        VARIABLE regValue : STD_LOGIC_VECTOR(2 DOWNTO 0);
    BEGIN
        
        IF(clk='1') THEN
            regValue(2 DOWNTO 0) := wbIn;
        END IF;
        wb_sel <= regValue(2 DOWNTO 1);
        wb_enable <= regValue(0);
    END PROCESS name;
END ARCHITECTURE memwbc_behav;
